<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for ConfigurationSearch StructType
 * @subpackage Structs
 */
class ConfigurationSearch extends AbstractStructBase
{
    /**
     * The SiteSearchData
     * @var \StructType\SiteSearchData
     */
    public $SiteSearchData;
    /**
     * The SearchRange
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchRange
     */
    public $SearchRange;
    /**
     * Constructor method for ConfigurationSearch
     * @uses ConfigurationSearch::setSiteSearchData()
     * @uses ConfigurationSearch::setSearchRange()
     * @param \StructType\SiteSearchData $siteSearchData
     * @param \StructType\SearchRange $searchRange
     */
    public function __construct(\StructType\SiteSearchData $siteSearchData = null, \StructType\SearchRange $searchRange = null)
    {
        $this
            ->setSiteSearchData($siteSearchData)
            ->setSearchRange($searchRange);
    }
    /**
     * Get SiteSearchData value
     * @return \StructType\SiteSearchData|null
     */
    public function getSiteSearchData()
    {
        return $this->SiteSearchData;
    }
    /**
     * Set SiteSearchData value
     * @param \StructType\SiteSearchData $siteSearchData
     * @return \StructType\ConfigurationSearch
     */
    public function setSiteSearchData(\StructType\SiteSearchData $siteSearchData = null)
    {
        $this->SiteSearchData = $siteSearchData;
        return $this;
    }
    /**
     * Get SearchRange value
     * @return \StructType\SearchRange|null
     */
    public function getSearchRange()
    {
        return $this->SearchRange;
    }
    /**
     * Set SearchRange value
     * @param \StructType\SearchRange $searchRange
     * @return \StructType\ConfigurationSearch
     */
    public function setSearchRange(\StructType\SearchRange $searchRange = null)
    {
        $this->SearchRange = $searchRange;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\ConfigurationSearch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
