<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for DoorSearch StructType
 * @subpackage Structs
 */
class DoorSearch extends AbstractStructBase
{
    /**
     * The DoorSearchData
     * @var \StructType\DoorSearchData
     */
    public $DoorSearchData;
    /**
     * The SearchRange
     * Meta informations extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SearchRange
     */
    public $SearchRange;
    /**
     * Constructor method for DoorSearch
     * @uses DoorSearch::setDoorSearchData()
     * @uses DoorSearch::setSearchRange()
     * @param \StructType\DoorSearchData $doorSearchData
     * @param \StructType\SearchRange $searchRange
     */
    public function __construct(\StructType\DoorSearchData $doorSearchData = null, \StructType\SearchRange $searchRange = null)
    {
        $this
            ->setDoorSearchData($doorSearchData)
            ->setSearchRange($searchRange);
    }
    /**
     * Get DoorSearchData value
     * @return \StructType\DoorSearchData|null
     */
    public function getDoorSearchData()
    {
        return $this->DoorSearchData;
    }
    /**
     * Set DoorSearchData value
     * @param \StructType\DoorSearchData $doorSearchData
     * @return \StructType\DoorSearch
     */
    public function setDoorSearchData(\StructType\DoorSearchData $doorSearchData = null)
    {
        $this->DoorSearchData = $doorSearchData;
        return $this;
    }
    /**
     * Get SearchRange value
     * @return \StructType\SearchRange|null
     */
    public function getSearchRange()
    {
        return $this->SearchRange;
    }
    /**
     * Set SearchRange value
     * @param \StructType\SearchRange $searchRange
     * @return \StructType\DoorSearch
     */
    public function setSearchRange(\StructType\SearchRange $searchRange = null)
    {
        $this->SearchRange = $searchRange;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\DoorSearch
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
